<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/parameters.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/parameters.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2004-2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PARAMETERS__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PARAMETERS__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf__implementation_8h.html">csutil/scf_implementation.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakref_8h.html">csutil/weakref.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/hash_8h.html">csutil/hash.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector3_8h.html">csgeom/vector3.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refarr_8h.html">csutil/refarr.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;physicallayer/pl.h&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">class </span><a class="code" href="classcelVariableParameterBlock.html" title="Variable parameter block implementation.">celVariableParameterBlock</a>;
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>;
<a name="l00035"></a>00035 
<a name="l00037"></a><a class="code" href="structcelParSpec.html">00037</a> <span class="keyword">struct </span><a class="code" href="structcelParSpec.html" title="The description of a parameter.">celParSpec</a>
<a name="l00038"></a>00038 {
<a name="l00040"></a><a class="code" href="structcelParSpec.html#a615ca08dbe7621c5bf4aba894194789b">00040</a>   celDataType <a class="code" href="structcelParSpec.html#a615ca08dbe7621c5bf4aba894194789b" title="The type of the parameter.">type</a>;
<a name="l00041"></a>00041 
<a name="l00043"></a><a class="code" href="structcelParSpec.html#adb2cb8903223af67e1530fb9fdc6c7d2">00043</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> <a class="code" href="structcelParSpec.html#adb2cb8903223af67e1530fb9fdc6c7d2" title="The ID of the parameter.">id</a>;
<a name="l00044"></a>00044 
<a name="l00046"></a><a class="code" href="structcelParSpec.html#ac746c8052498cc2d3ef3b7a5e94d4983">00046</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="structcelParSpec.html#ac746c8052498cc2d3ef3b7a5e94d4983" title="The name of the parameter.">name</a>;
<a name="l00047"></a>00047 
<a name="l00049"></a><a class="code" href="structcelParSpec.html#a759d92d4f05d7a09d275553afce5d658">00049</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> <a class="code" href="structcelParSpec.html#a759d92d4f05d7a09d275553afce5d658" title="The value of the parameter.">value</a>;
<a name="l00050"></a>00050 };
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00060"></a><a class="code" href="structiParameter.html">00060</a> <span class="comment"></span><span class="keyword">struct </span><a class="code" href="structiParameter.html" title="This interface represents a parameter to a sequence, trigger, or reward.">iParameter</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   SCF_INTERFACE (<a class="code" href="structiParameter.html" title="This interface represents a parameter to a sequence, trigger, or reward.">iParameter</a>, 0, 0, 2);
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiParameter.html#a389241657ce5b70c74c0f2190d0455a7" title="Get this variable as its correct datatype.">GetData</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00068"></a>00068 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiParameter.html#a0e867fb6c039cdca1a35a5a0af089436" title="Get the value of this expression as a string.">Get</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00074"></a>00074 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiParameter.html#a0e867fb6c039cdca1a35a5a0af089436" title="Get the value of this expression as a string.">Get</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params, <span class="keywordtype">bool</span>&amp; changed) = 0;
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a> <a class="code" href="structiParameter.html#aeb0b64530a715654888c92b4af56a41a" title="Get the value of this expression as a long.">GetLong</a> (<a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params) = 0;
<a name="l00089"></a>00089 };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00093"></a>00093 <span class="comment"></span><span class="keyword">typedef</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">csHash&lt;csStringBase,csStringBase&gt;</a> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>;
<a name="l00094"></a>00094 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00095"></a>00095 
<a name="l00101"></a><a class="code" href="structiParameterManager.html">00101</a> <span class="keyword">struct </span><a class="code" href="structiParameterManager.html" title="This interface provides a generic functions for the evaluation of any type of parameter (constant...">iParameterManager</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103     SCF_INTERFACE (<a class="code" href="structiParameterManager.html" title="This interface provides a generic functions for the evaluation of any type of parameter (constant...">iParameterManager</a>, 1, 0, 0);
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iParameter&gt;</a> <a class="code" href="structiParameterManager.html#ad0d5a6e38732d05f2c9206cf43d67941" title="Get a parameter that can be evalulated later on an as-needed basis.">GetParameter</a> (
<a name="l00110"></a>00110         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params,
<a name="l00111"></a>00111         <span class="keyword">const</span> <span class="keywordtype">char</span>* param) = 0;
<a name="l00112"></a>00112 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiParameterManager.html#a20362f81f86ca84648c18eebcb87f7bf" title="This is a convenience function to resolve a quest parameter during creation of rewards, triggers, and sequence operations.">ResolveParameter</a> (
<a name="l00122"></a>00122         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params,
<a name="l00123"></a>00123         <span class="keyword">const</span> <span class="keywordtype">char</span>* param) = 0;
<a name="l00124"></a>00124 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;celVariableParameterBlock&gt;</a> <a class="code" href="structiParameterManager.html#abc9256cc531285f31dd0cb43f012be6f" title="This is a convenience function to get a parameter block during creation of rewards, triggers, and sequence operations.">GetParameterBlock</a> (
<a name="l00136"></a>00136         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params,
<a name="l00137"></a>00137         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;celParSpec&gt;</a>&amp; parameters,
<a name="l00138"></a>00138         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray&lt;iParameter&gt;</a>&amp; quest_parameters) = 0;
<a name="l00139"></a>00139 
<a name="l00149"></a>00149   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiParameterManager.html#a7c72e14baf9d4c668d1f43ebd33b058b" title="Fill in the dynamic parameters in a parameter block.">FillParameterBlock</a> (
<a name="l00150"></a>00150     <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params,
<a name="l00151"></a>00151         <a class="code" href="classcelVariableParameterBlock.html" title="Variable parameter block implementation.">celVariableParameterBlock</a>* act_params,
<a name="l00152"></a>00152         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;celParSpec&gt;</a>&amp; parameters,
<a name="l00153"></a>00153         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray&lt;iParameter&gt;</a>&amp; quest_parameters) = 0;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 <span class="comment">//---------------------------------------------------------------------------</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#endif // __CEL_PARAMETERS__</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
